/**
******************************************************************************
* @file         udp_multicast.c
* @version      V1.0
* @date         2020-06-05
* @brief        udpЭ飬鲥ݻػ
*
* @company      Ƽ޹˾
* @information  WIZnet W5500ٷ̣ȫ̼֧֣۸ƴ
* @website      www.wisioe.com
* @forum        www.w5500.cn
* @qqGroup      579842114
* @Support      QQ:2571856470Mob:18998931307
* @Email        support@wisioe.com
******************************************************************************
*/
#include <stdio.h>
#include "udp_multicast.h"
#include "socket.h"
#include "w5500.h"
#include "w5500_conf.h"

uint8_t buff[DATA_BUF_SIZE];  

uint16 Multicast_port = 3000;                              // 鲥˿
uint8 Multicast_mac[6] = {0x01,0x00,0x5e,0x01,0x01,0x0b};  // 鲥MAC
uint8 Multicast_IP[4] = {224,1,1,11};                      // 鲥IP

void udp_multicast_init(uint8 s,uint8* addr,uint16 port,uint8* mac)
{
	/* дĿIPַ */
    wiz_write_buf(Sn_DIPR0(s),addr,4);  
	/* дĿMACַ */
    wiz_write_buf(Sn_DHAR0(s),mac,6); 
	/* дĿ˿ں */
	IINCHIP_WRITE( Sn_DPORT0(s),(uint8)((port & 0xff00) >> 8));
	IINCHIP_WRITE( Sn_DPORT1(s),(uint8)(port & 0x00ff));
	/* д˿ں */
	IINCHIP_WRITE( Sn_PORT0(s) ,(uint8)((port & 0xff00) >> 8));
	IINCHIP_WRITE( Sn_PORT1(s) ,(uint8)(port & 0x00ff));
}

void do_udp_multicast(void)
{
  uint8 len;
  switch(getSn_SR(SOCK_UDPS))                                                  // ȡsocket״̬
  {
    case SOCK_CLOSED:                                                          // socketڹر״̬
			udp_multicast_init(SOCK_UDPS,Multicast_IP,Multicast_port,Multicast_mac); // UDP鲥
      socket(SOCK_UDPS,Sn_MR_UDP_MULTICAST,Multicast_port,0);                  // ʼsocket鲥ģʽ(socketײ޸)
      break;    
    case SOCK_UDP:                                                             // socketʼ
      if(getSn_IR(SOCK_UDPS) & Sn_IR_RECV)
      {
        setSn_IR(SOCK_UDPS, Sn_IR_RECV);                                       // ж
      }
      if((len=getSn_RX_RSR(SOCK_UDPS))>0)                                      // յ
      {
        buff[len-8]=0x00;                                                      // ַ
        recvfrom(SOCK_UDPS,buff, len, Multicast_IP,&Multicast_port);           // W5500ռ                                                   
        printf("%s\r\n",buff);                                                 // ӡջ 
        sendto(SOCK_UDPS,buff,len-8, Multicast_IP, Multicast_port);            // W5500ѽյݷ͸Remote
      }
      break;  
  }
}
