/**
******************************************************************************
* @file         udp_multicast.h
* @version      V1.0
* @date         2020-06-05
* @brief        udp_multicast.cͷļ
*        
* @company      Ƽ޹˾
* @information  WIZnet W5500ٷ̣ȫ̼֧֣۸ƴ
* @website      www.wisioe.com
* @forum        www.w5500.cn
* @qqGroup      579842114
* @Support      QQ:2571856470Mob:18998931307
* @Email        support@wisioe.com
******************************************************************************
*/
#ifndef _UDP_MULTICAST_H_
#define _UDP_MULTICAST_H_

#include <stdint.h>
#include "types.h"

/* DATA_BUF_SIZE define for Loopback example */
#ifndef DATA_BUF_SIZE
#define DATA_BUF_SIZE  2048
#endif

extern uint16 Multicast_port;
extern uint8 Multicast_IP[4];

#define Sn_MR_UDP_MULTICAST 0x92

/* UDP Multicast Initialization Configuration */
void udp_multicast_init(uint8 s,uint8* addr,uint16 port,uint8* mac);

/* UDP Multicast Loopback test example */
void do_udp_multicast(void);

#endif
